## qtmir 0.6.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(qtmir)

set(QTMIR_VERSION_MAJOR 0)
set(QTMIR_VERSION_MINOR 6)
set(QTMIR_VERSION_PATCH 1)

set(QTMIR_VERSION ${QTMIR_VERSION_MAJOR}.${QTMIR_VERSION_MINOR}.${QTMIR_VERSION_PATCH})

if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
   message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt and CMakeFiles/ from source root and try again.")
endif()

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package (ECM 1.7.0 QUIET NO_MODULE)
if (ECM_FOUND)
    # Provides us with -DECM_ENABLE_SANITIZERS='X'
    # Where X can be address, thread, memory, leak, undefined
    include("${ECM_MODULE_DIR}/ECMEnableSanitizers.cmake")
endif()

# add custom cmake modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -Wextra -Werror")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -fno-strict-aliasing -Werror -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

set (CMAKE_CXX_STANDARD 14)

if ("${CMAKE_CXX_COMPILER}" MATCHES "clang")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-return-type-c-linkage -Wno-mismatched-tags -Wno-inconsistent-missing-override -Wno-implicit-exception-spec-mismatch -Wno-unknown-pragmas")
endif()


#find_package(CoverageReport)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage (or ninja if you use that backend)
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
if(cmake_build_type_lower MATCHES coverage)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage" )
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage" )
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage" )
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage" )
    ENABLE_COVERAGE_REPORT(TARGETS ${SHELL_APP} FILTER /usr/include ${CMAKE_SOURCE_DIR}/tests/* ${CMAKE_BINARY_DIR}/*)
endif()

# Make sure we have all the needed symbols
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,defs")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-z,defs")

# Static C++ checks
add_custom_target(cppcheck COMMAND cppcheck --enable=all -q --error-exitcode=2
                                       ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/tests)

option(WITH_CONTENTHUB "Build with content-hub" OFF)

include(FindPkgConfig)
find_package(Qt5Core 5.9 REQUIRED)
find_package(Qt5DBus 5.9 REQUIRED)
find_package(Qt5Gui 5.9 REQUIRED)
find_package(Qt5Qml 5.9 REQUIRED)
find_package(Qt5Quick 5.9 REQUIRED)
find_package(Qt5Sensors 5.9 REQUIRED)
find_package(Qt5Test 5.9 REQUIRED)

find_package(Threads REQUIRED)

pkg_check_modules(MIRSERVER mirserver>=0.26 REQUIRED)
pkg_check_modules(MIRCLIENT mirclient>=0.26 REQUIRED)
pkg_check_modules(MIRRENDERERGLDEV mir-renderer-gl-dev>=0.26 REQUIRED)
pkg_check_modules(MIRAL miral>=1.1.0 REQUIRED)

pkg_check_modules(XKBCOMMON xkbcommon REQUIRED)
pkg_check_modules(GLIB glib-2.0 REQUIRED)
pkg_check_modules(PROCESS_CPP process-cpp REQUIRED)
pkg_check_modules(LOMIRI_APP_LAUNCH lomiri-app-launch-0 REQUIRED)
pkg_check_modules(URL_DISPATCHER lomiri-url-dispatcher REQUIRED)
pkg_check_modules(EGL egl)
pkg_check_modules(GIO gio-2.0)
pkg_check_modules(GIO_UNIX gio-unix-2.0)
pkg_check_modules(LTTNG lttng-ust)
pkg_check_modules(GSETTINGS_QT REQUIRED gsettings-qt)
pkg_check_modules(QTDBUSTEST libqtdbustest-1 REQUIRED)
pkg_check_modules(QTDBUSMOCK libqtdbusmock-1 REQUIRED)
pkg_check_modules(APPLICATION_API REQUIRED lomiri-shell-application=27)
pkg_check_modules(CGMANAGER libcgmanager REQUIRED)
pkg_check_modules(VALGRIND valgrind REQUIRED)

if(WITH_CONTENTHUB)
pkg_check_modules(CONTENT_HUB libcontent-hub>=0.2 REQUIRED)
message(STATUS "Bulding with content-hub")
endif()

include_directories(SYSTEM ${APPLICATION_API_INCLUDE_DIRS})

# Disable all deprecated qt functions in and before qt version 5.9
add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x050900)

# Use the fast string builder
add_definitions(-DQT_USE_QSTRINGBUILDER)

# We expect this to be set via debian/rules for GLES builds
if ("${USE_OPENGLES}" STREQUAL 1)
    message(STATUS "Qt5 determined to be compiled with GLES support")
    pkg_check_modules(GLESv2 glesv2)
    add_definitions(-DQT_USING_GLES)
    include_directories (SYSTEM ${GLESv2_INCLUDE_DIRS})
    set (GL_LIBRARIES "${GLESv2_LIBRARIES}")
# Because qt/gl and qt/gles are not parallel installable we have a difficulty
# building qtmir-desktop on armhf. We would like to link against opengl and bind the
# opengl API but Qt is already linked against the ES APIs. So in this setup we link against OpenGLES
# to accomodate Qt but bind the OpenGL API anyway. This is technically broken though
# I suspect Mesa may allow it ~racarr.
elseif("${USE_OPENGL_BUT_LINK_AGAINST_OPENGLES}")
    message(STATUS "Linking against OpenGL ES but binding OpenGL API")
    pkg_check_modules(GLESv2 glesv2)
    add_definitions(-DQT_USING_GL)
    include_directories (SYSTEM ${GLESv2_INCLUDE_DIRS})
    set (GL_LIBRARIES "${GLESv2_LIBRARIES}")
else()
    message(STATUS "Qt5 determined to be compiled with OpenGL support")
    pkg_check_modules(GL gl)
    add_definitions(-DQT_USING_OPENGL)
    include_directories (SYSTEM ${GL_INCLUDE_DIRS})
endif()

# Standard install paths
include(GNUInstallDirs)


# Determine QPA plugin install path
# FIXME(greyback) there must be a better way than calling a private macro to set a property.
# I'm manually calling a macro from Qt5GuiConfig.cmake, but I don't understand why it isn't being called.
if (Qt5Gui_VERSION VERSION_LESS 5.14.0)
  _populate_Gui_plugin_properties("Gui" "PLATFORMS" "platforms")
else()
  _populate_Gui_plugin_properties("Gui" "PLATFORMS" "platforms" FALSE)
endif()
get_target_property(Qt5Gui_QPA_Plugin_Path Qt5::Gui IMPORTED_LOCATION_PLATFORMS)

# Set QML module install path
set(QML_MODULE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/qt5/qml")
set(QTMIR_DATA_DIR ${CMAKE_INSTALL_DATADIR}/qtmir)


# Customisations for the build type
if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "Setting build type to 'RelWithDebInfo' as none was specified.")
    set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

if(cmake_build_type_lower MATCHES relwithdebinfo) # workaround for http://public.kitware.com/Bug/view.php?id=14696
    add_definitions(-DQT_NO_DEBUG)
endif()
if ("${CMAKE_BUILD_TYPE}" STREQUAL "release" OR "${CMAKE_BUILD_TYPE}" STREQUAL "relwithdebinfo")
    option(Werror "Treat warnings as errors" ON)
else()
    option(Werror "Treat warnings as errors" OFF)
endif()

if (Werror)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()


# Mir uses boost, which does not like Qt defining macros named "signals" and "slots"
add_definitions(-DQT_NO_KEYWORDS)

# Tests
if (NO_TESTS)
    message(STATUS "Tests disabled")
else()
    include(CTest)
    enable_testing()
    add_subdirectory(tests)
endif()

# add subdirectories to build
add_subdirectory(src)
add_subdirectory(demos)
add_subdirectory(benchmarks)

=== demos/CMakeLists.txt ===
configure_file(paths.h.in ${CMAKE_CURRENT_BINARY_DIR}/paths.h @ONLY)

add_subdirectory(qml-demo-client)
add_subdirectory(qml-demo-shell)

=== tests/CMakeLists.txt ===
find_package(GMock)

pkg_check_modules(GTEST gtest)
if(NOT GTEST_FOUND)
    message(WARNING "'gtest' not found with pkg-config, assuming v1.7.0")
    set(GTEST_VERSION "1.7.0")
endif()
string(REGEX MATCH
    "([0-9])\\.([0-9]+)\\.([0-9])" GTEST_VERSION_PARSED
    ${GTEST_VERSION})
if (GTEST_VERSION_PARSED)
    set(GTEST_VERSION_MAJOR ${CMAKE_MATCH_1})
    set(GTEST_VERSION_MINOR ${CMAKE_MATCH_2})
    set(GTEST_VERSION_PATCH ${CMAKE_MATCH_3})
    message("Using GTest v${GTEST_VERSION_MAJOR}.${GTEST_VERSION_MINOR}.${GTEST_VERSION_PATCH}")
else()
    set(GTEST_VERSION_MAJOR 1)
    set(GTEST_VERSION_MINOR 8)
    set(GTEST_VERSION_PATCH 0)
    message(WARNING "Could not parse GTest version: ${GTEST_VERSION}, assuming v1.8.0 (or compatible) and hoping for the best")
endif()

add_definitions(-DGTEST_VERSION_MAJOR=${GTEST_VERSION_MAJOR})
add_definitions(-DGTEST_VERSION_MINOR=${GTEST_VERSION_MINOR})
add_definitions(-DGTEST_VERSION_PATCH=${GTEST_VERSION_PATCH})

include_directories(
    include
)

pkg_check_modules(MIRTEST mirtest>=0.26 REQUIRED)

add_subdirectory(framework)
add_subdirectory(mirserver)
add_subdirectory(modules)

add_test(
    NAME convert-to-gles
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/convert-to-gles.sh
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

add_test(
    NAME requires-provides
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/check-requires-provides.sh
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

=== demos/qml-demo-shell/CMakeLists.txt ===
set(DEMO_SHELL qtmir-demo-shell)

include_directories(
    SYSTEM

    ${CMAKE_SOURCE_DIR}/include

    ${MIRSERVER_INCLUDE_DIRS}
    ${MIRAL_INCLUDE_DIRS}

    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Qml_PRIVATE_INCLUDE_DIRS}
    ${Qt5Quick_PRIVATE_INCLUDE_DIRS}
)

add_executable(${DEMO_SHELL}
    pointerposition.cpp
    screenwindow.cpp
    screens.cpp
    main.cpp
)

target_link_libraries(
    ${DEMO_SHELL}

    qtmirserver

    Qt5::Core
    Qt5::DBus
    Qt5::Qml
    Qt5::Quick
)

file(GLOB QML_JS_FILES *.qml *.js *.png)

add_custom_target(${DEMO_SHELL}-qmlfiles
                  SOURCES ${QML_JS_FILES})

# install binaries
install(TARGETS ${DEMO_SHELL}
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
 )

install(FILES
    ${QML_JS_FILES}
    DESTINATION ${QTMIR_DATA_DIR}/${DEMO_SHELL}
)

=== src/modules/CMakeLists.txt ===
find_package(QmlPlugins)

# Set up and install a QML plugin.
#
# add_qml_plugin(plugin version path
#     [...]  # See export_qmlfiles and export_qmlplugin documentation for more options
# )

macro(add_qml_plugin PLUGIN VERSION PATH)
    export_qmlfiles(${PLUGIN} ${PATH} DESTINATION ${QML_MODULE_INSTALL_DIR} ${ARGN})
    export_qmlplugin(${PLUGIN} ${VERSION} ${PATH} DESTINATION ${QML_MODULE_INSTALL_DIR} ${ARGN})
endmacro()

add_subdirectory(Unity)

=== tests/framework/CMakeLists.txt ===
include_directories(
    ${CMAKE_SOURCE_DIR}/src/common
    ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
    ${CMAKE_SOURCE_DIR}/src/modules
)

include_directories(
    SYSTEM
    ${APPLICATION_API_INCLUDE_DIRS}
    ${MIRAL_INCLUDE_DIRS}
    ${MIRSERVER_INCLUDE_DIRS}
    ${MIRRENDERERGLDEV_INCLUDE_DIRS}
    ${MIRTEST_INCLUDE_DIRS}

    ${Qt5Quick_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
)

set(QTMIR_TEST_PRIVATE_SRC
    fake_application_info.cpp
    fake_mirsurface.cpp
    fake_session.cpp
    mock_application_info.cpp
    mock_main_loop.cpp
    mock_mir_session.cpp
    mock_proc_info.cpp
    mock_prompt_session.cpp
    mock_prompt_session_manager.cpp
    mock_renderable.cpp
    mock_session.cpp
    mock_sessionmap.h
    mock_settings.cpp
    mock_shared_wakelock.cpp
    mock_surface.cpp
    mock_task_controller.cpp
    mock_persistent_surface_store.cpp
    fake_surface.h
    fake_displayconfigurationoutput.h
    qtmir_test.cpp
)

add_library(qtmir-test-framework-static STATIC
    ${QTMIR_TEST_PRIVATE_SRC}
)

target_link_libraries(
    qtmir-test-framework-static

    unityapplicationplugin

    ${GTEST_BOTH_LIBRARIES}
    ${GMOCK_LIBRARIES}
)

=== tests/mirserver/CMakeLists.txt ===
add_subdirectory(EventBuilder)
add_subdirectory(QtEventFeeder)
add_subdirectory(Screen)
add_subdirectory(ScreensModel)
add_subdirectory(miral)

=== src/platforms/mirserver/CMakeLists.txt ===
# Qt5PlatformSupport is not available as a cmake module.
# And also not anymore as pkgconfig module since Qt 5.6.
#pkg_check_modules(QT5PLATFORM_SUPPORT Qt5PlatformSupport REQUIRED)
include(FindQt5PlatformSupport)
include(UseLttngGenTp)

set(QTMIRSERVER_ABI 1)

add_subdirectory(miral)

# Hacks for the QPA privates monster.
pkg_check_modules(FONTCONFIG fontconfig REQUIRED)

if (QGL_DEBUG)
    message(STATUS "Qt's OpenGL debug logging enabled.")
    add_definitions(-DQGL_DEBUG)
endif()

if (WITH_CONTENTHUB)
    add_definitions(-DWITH_CONTENTHUB)
endif()

#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11 -fPIC")

find_package(Qt5FontDatabaseSupport REQUIRED)
find_package(Qt5ThemeSupport REQUIRED)
find_package(Qt5EventDispatcherSupport REQUIRED)
find_package(Qt5EglSupport REQUIRED)
find_package(Qt5ServiceSupport REQUIRED)
set(QT5PLATFORMSUPPORT_LIBS
    Qt5FontDatabaseSupport::Qt5FontDatabaseSupport
    Qt5ThemeSupport::Qt5ThemeSupport
    Qt5EventDispatcherSupport::Qt5EventDispatcherSupport
    Qt5EglSupport::Qt5EglSupport
    Qt5ServiceSupport::Qt5ServiceSupport
)

include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/src/common
    ${CMAKE_CURRENT_BINARY_DIR} # for tracepoints.h
)

include_directories(
    SYSTEM
    ${MIRAL_INCLUDE_DIRS}
    ${MIRCOMMON_INCLUDE_DIRS}
    ${MIRSERVER_INCLUDE_DIRS}
    ${MIRRENDERERGLDEV_INCLUDE_DIRS}
    ${MIRSERVER_INCLUDE_DIRS}

    ${URL_DISPATCHER_INCLUDE_DIRS}
    ${EGL_INCLUDE_DIRS}
    ${LTTNG_INCLUDE_DIRS}

    ${Qt5Gui_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}


    ${Qt5Quick_INCLUDE_DIRS}
    ${Qt5Quick_PRIVATE_INCLUDE_DIRS}
    ${Qt5Qml_INCLUDE_DIRS}

    ${APPLICATION_API_INCLUDE_DIRS}

if(WITH_CONTENTHUB)
    ${CONTENT_HUB_INCLUDE_DIRS}
endif()

    ${VALGRIND_INCLUDE_DIRS}
)

# We have to remove -pedantic for tracepoints.c
string (REPLACE " -pedantic " " " TRACEPOINTS_CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
# BYTE_ORDER needed to compile tracepoints in C99 mode.
set(TRACEPOINTS_CMAKE_C_FLAGS "${TRACEPOINTS_CMAKE_C_FLAGS} -DBYTE_ORDER=__BYTE_ORDER -fPIC ")
set_source_files_properties(tracepoints.c PROPERTIES COMPILE_FLAGS "${TRACEPOINTS_CMAKE_C_FLAGS}")

# Generate tracepoints.c and .h from tracepoints.tp
add_lttng_gen_tp(NAME tracepoints)
add_custom_target(MirServer_LTTNG
    DEPENDS tracepoints.h tracepoints.c
)

if(WITH_CONTENTHUB)
    set(CLIPBOARD_SRC clipboard.cpp)
endif()

# These files will compile without mirserver-dev
add_library(qtmirserver-nomirserver OBJECT
    ${CMAKE_SOURCE_DIR}/src/common/timestamp.cpp
    ${CLIPBOARD_SRC}
    logging.cpp
    shelluuid.cpp
    mirsingleton.cpp
    wrappedsessionauthorizer.cpp
    promptsessionlistener.cpp
    displayconfigurationstorage.cpp
    nativeinterface.cpp
    services.cpp
    windowcontroller.cpp
    workspacecontroller.cpp
    tracepoints.c
    surfaceobserver.cpp
    initialsurfacesizes.cpp
    orientationsensor.cpp
    screenadaptor.cpp
    screenadaptormodel.cpp
    qtmir.cpp
)
add_dependencies(qtmirserver-nomirserver MirServer_LTTNG)

include_directories(SYSTEM ${MIRSERVER_INCLUDE_DIRS})

# These files will only compile with mirserver-dev
add_library(qtmirserver-mirserver OBJECT
    openglcontextfactory.cpp openglcontextfactory.h
    mircursorimages.cpp
    screenscontroller.cpp
    qtcompositor.cpp
    displayconfigurationpolicy.cpp
    wrappedwindowmanagementpolicy.cpp
    mirdisplayconfigurationobserver.cpp
    mirserverhooks.cpp mirserverhooks.h
    setqtcompositor.cpp setqtcompositor.h
    eventdispatch.cpp eventdispatch.h
    promptsessionmanager.cpp promptsessionmanager.h promptsession.h
)

# These files get entangled by automoc so they need to go together. And some depend on mirserver-dev
set(QMIRSERVER_PLUGIN_SRC
    ${CMAKE_SOURCE_DIR}/src/common/debughelpers.cpp
    cursor.cpp
    eventbuilder.cpp
    qteventfeeder.cpp
    qmirserver.cpp
    qmirserver_p.cpp
    platformscreen.cpp
    screenplatformwindow.cpp
    screensmodel.cpp
    miropenglcontext.cpp
    offscreensurface.cpp
    inputdeviceobserver.cpp
    mirserverapplication.cpp
    windowmodelnotifier.cpp

# We need to run moc on these headers
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/MirMousePointerInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/Mir.h

    ${CMAKE_SOURCE_DIR}/include/qtmir/mirserverapplication.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/displayconfigurationpolicy.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/sessionauthorizer.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/windowmanagementpolicy.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/displayconfigurationstorage.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/screen.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/screens.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/types.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/qtmir.h

    ${CMAKE_SOURCE_DIR}/src/common/windowcontrollerinterface.h
    ${CMAKE_SOURCE_DIR}/src/common/workspacecontrollerinterface.h
    ${CMAKE_SOURCE_DIR}/src/common/windowmodelnotifier.h
    ${CMAKE_SOURCE_DIR}/src/common/appnotifier.h
)

add_library(qtmirserver SHARED
    ${QMIRSERVER_PLUGIN_SRC}
    $<TARGET_OBJECTS:qtmirserver-nomirserver>
    $<TARGET_OBJECTS:qtmirserver-mirserver>
    $<TARGET_OBJECTS:miral-prototypes>
)

target_link_libraries(qtmirserver
    PUBLIC
        ${MIRAL_LDFLAGS}
        ${MIRSERVER_LDFLAGS}
        Qt5::Core
        Qt5::Gui

    PRIVATE
        ${URL_DISPATCHER_LDFLAGS}
        ${EGL_LDFLAGS}
        ${GL_LIBRARIES}
        ${LTTNG_LIBRARIES}
        ${GIO_LDFLAGS}
        ${FONTCONFIG_LDFLAGS}
        ${XKBCOMMON_LIBRARIES}

        ${CONTENT_HUB_LIBRARIES}

        Qt5::DBus
        Qt5::Quick
        Qt5::Sensors
        ${QT5PLATFORMSUPPORT_LIBS}
)

set_target_properties(qtmirserver
  PROPERTIES
  SOVERSION ${QTMIRSERVER_ABI}
)

set(LIBDIR "${CMAKE_INSTALL_FULL_LIBDIR}")
set(INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include/qtmir")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qtmirserver.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/qtmirserver.pc
    @ONLY
)

install(
  TARGETS qtmirserver
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(
  DIRECTORY ${CMAKE_SOURCE_DIR}/include/qtmir
  DESTINATION "include/qtmir"
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/qtmirserver.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)


add_library(qpa-mirserver SHARED
    mirserverintegration.cpp
    plugin.cpp
)

target_link_libraries(qpa-mirserver
PRIVATE
    qtmirserver
    ${QT5PLATFORMSUPPORT_LIBS}

    ${MIRSERVER_LDFLAGS}
    ${URL_DISPATCHER_LDFLAGS}
    ${EGL_LDFLAGS}
    ${GL_LIBRARIES}
    ${LTTNG_LIBRARIES}
    ${GIO_LDFLAGS}
    ${FONTCONFIG_LDFLAGS}
    ${XKBCOMMON_LIBRARIES}

    ${CONTENT_HUB_LIBRARIES}

    Qt5::Core
    Qt5::DBus
    Qt5::Quick
    Qt5::Sensors
    Qt5::Qml
)

install(TARGETS qpa-mirserver LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}/qt5/plugins/platforms")

=== tests/mirserver/EventBuilder/CMakeLists.txt ===
set(
  EVENT_BUILDER_TEST_SOURCES
  eventbuilder_test.cpp
)

include_directories(
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
  ${CMAKE_SOURCE_DIR}/src/common
)

include_directories(
  SYSTEM
  ${MIRSERVER_INCLUDE_DIRS}
)

add_executable(EventBuilderTest ${EVENT_BUILDER_TEST_SOURCES})

target_link_libraries(
  EventBuilderTest
  qtmirserver
  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}
)

add_test(EventBuilder, EventBuilderTest)

=== tests/mirserver/ScreensModel/CMakeLists.txt ===
set(
  SCREENCONTROLLER_TEST_SOURCES
  screensmodel_test.cpp
  ${CMAKE_SOURCE_DIR}/src/common/debughelpers.cpp
  # to be moc-ed
  stub_screen.h
  testable_screensmodel.h
)

include_directories(
  ${CMAKE_SOURCE_DIR}/include
  ${CMAKE_SOURCE_DIR}/tests/framework
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
  ${CMAKE_SOURCE_DIR}/src/common
)

include_directories(
  SYSTEM
  ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
  ${MIRSERVER_INCLUDE_DIRS}
  ${MIRRENDERERGLDEV_INCLUDE_DIRS}
  ${MIRTEST_INCLUDE_DIRS}
)

add_executable(ScreensModelTest ${SCREENCONTROLLER_TEST_SOURCES})

set_property(TARGET ScreensModelTest PROPERTY CXX_STANDARD 14)

target_link_libraries(
  ScreensModelTest
  qtmirserver

  -L${CMAKE_BINARY_DIR}/tests/framework
  qtmir-test-framework-static

  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}
)

add_test(ScreensModel, ScreensModelTest)

=== tests/mirserver/miral/CMakeLists.txt ===
set(
  MIRAL_TEST_SOURCES
  edid_test.cpp
)

include_directories(
    ${CMAKE_SOURCE_DIR}/include
)

add_executable(MirALTests ${MIRAL_TEST_SOURCES})

target_link_libraries(MirALTests
  qtmirserver
  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}
)

add_test(MirAL, MirALTests)

=== tests/modules/Application/CMakeLists.txt ===
set(
  APPLICATION_TEST_SOURCES
  application_test.cpp
)

include_directories(
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
  ${CMAKE_SOURCE_DIR}/src/modules
  ${CMAKE_SOURCE_DIR}/tests/framework
)

include_directories(
  SYSTEM
  ${MIRAL_INCLUDE_DIRS}
  ${MIRSERVER_INCLUDE_DIRS}
  ${Qt5Core_INCLUDE_DIRS}
  ${Qt5Gui_INCLUDE_DIRS}
  ${Qt5Quick_INCLUDE_DIRS}
  ${Qt5DBus_INCLUDE_DIRS}
)

add_executable(application_test ${APPLICATION_TEST_SOURCES})

add_dependencies(application_test qtmir-test-framework-static)

target_link_libraries(
  application_test

  Qt5::Test

  unityapplicationplugin

  -L${CMAKE_BINARY_DIR}/tests/framework
  qtmir-test-framework-static

  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}
)

add_test(Application, application_test)

=== debian/changelog ===
qtmir (0.6.1-7) unstable; urgency=medium

  * debian/libqtmirserver1.symbols:
    + Update for architectures arm64, m68k, mips64el and sh4.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 14 Mar 2021 21:36:52 +0100

qtmir (0.6.1-6) unstable; urgency=medium

  * debian/control:
    + Limit qtmir to linux-any architecture builds.
  * debian/patches:
    + Add 0001_demo-fix-detecting-running-installed.patch,
      0002_demos-fix-application-name.patch. Fix loading demo shell and demo
      client.
    + Add 2004_qml-demo-shell-work-without-ui-toolkit.patch. Make qml-demo-shell
      work without lomiri-ui-toolkit.
  * debian/rules:
    + Move qtmir-demo-shell files to the correct location.
  * debian/qtmir-tests.install:
    + Pick up files for qtmir-demo-shell and qtmir-demo-client from the correct
      location (as moved around by d/rules).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 10 Mar 2021 21:08:51 +0100

qtmir (0.6.1-5) unstable; urgency=medium

  * debian/control:
    + Replace D (qtmir-tests): qtdeclarative5-qtmir-plugin by qml-module-qtmir,
      drop from D (qtmir-tests): autopilot-qt5 and python3-autopilot. (Closes:
      #977134).
    + Bump Standards-Version: to 4.5.1. No changes needed.
  * debian/qtmir-tests.install:
    + Drop DATADIR/qtmir/benachmarks/* from qtmir-tests bin:pkg.
  * debian/patches:
    + Add 2003_disable-benchmarks.patch. No autopilot in Debian, so let's build
      qtmir without dependency on it (i.e. without benchmarks).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 16 Dec 2020 16:32:50 +0100

qtmir (0.6.1-4) unstable; urgency=medium

  * debian/libqtmirserver1.symbols:
    + Update for armel architecture. (Closes: #973423).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 30 Oct 2020 19:56:05 +0100

qtmir (0.6.1-3) unstable; urgency=medium

  * debian/patches:
    + Add 1008_drop-Werror-enforcement-leave-it-to-configure-option.patch. Fix
      disabling -Werror via CMake configure option.
  * debian/rules:
    + Build with CMake option '-DWerror=OFF'. (Closes: #973437).
  * debian/libqtmirserver1.symbols:
    + Update after rebuild against Qt 5.15 (amd64 only for now).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 30 Oct 2020 17:45:48 +0100

qtmir (0.6.1-2) unstable; urgency=medium

  * debian/control:
    + Only require valgrind as B-D on architectures where it is available on.
  * debian/patches:
    + Add 1007_make-valgrind-dependency-optional.patch. Make Valgrind an
      optional build dependency.
  * debian/libqtmirserver1.symbols:
    + Update symbols for armhf i386 mipsel ppc64el.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 28 Oct 2020 14:33:37 +0100

qtmir (0.6.1-1) unstable; urgency=medium

  * Initial upload to Debian (Closes: #971257).
  * debian/*:
    + Rename bin:pkg qtdeclarative5-qtmir-plugin to qml-module-qtmir.
  * debian/watch:
    + Add file.
  * debian/control:
    + Adjust B-Ds for googletest.
    + Drop B-D libcontent-hub-dev.
    + Drop B-D on libcgmanager-dev. (Package not available in Debian anymore).
    + Drop B-D on libmirclient-dev. Not required anymore with qtmir 0.6.1.
    + Fix dev:pkg name provided by lomiri-app-launch.
    + Fix versioned B-D on lomiri-api-dev. Remnant of Unity8 -> Lomiri
      migration.
    + Update versioned B-D: cmake-extras (>= 1.5-4~).
    + Drop from B-D: qt5-default (meta package).
    + Bump Standards-Version: to 4.5.0. No changes needed.
    + Bump DH compat level to version 13.
    + Add Vcs-*: fields.
    + Assure binNMU'ability between bin:pkgs in this src:pkg.
    + Add Rules-Requires-Root: field and set it to 'no'.
    + Add B-D pkg-kde-tools.
    + Drop Section: field duplicating global Section: field.
    + Improve LONG_DESCRIPTION fields of two bin:pkgs.
    + Turn bin:pkg qtmir-tests into Multi-Arch: foreign.
    + Move qtmir-tests bin:pkg into section 'libdevel'.
    + Adjust Maintainer: field and Uploaders: field to official upload to
      Debian.
    + Add Debian Qt/KDE Maintainers to Uploaders: field.
  * debian/rules:
    + Add get-orig-source target.
    + Move --fail-missing flag into dh_missing override.
    + Remove build-*/ during dh_clean. Makes build idempotent.
    + Don't build WITH_CONTENTHUB anymore. Obsolete in qtmir 0.6.1.
    + Drop now default --parallel DH build option.
    + Enable all hardening build flags.
    + Build with pkgkde_symbolshelper.
  * debian/patches:
    + Add 1002_drop-cgmanager-dependency.patch. Rip out cgmanager dependent
      code. This has been sanctioned by upstream.
    + Add 1003_INSTANTIATE_TEST_SUITE.patch. Use INSTANTIATE_TEST_SUITE macro,
      rather than deprecated INSTANTIATE_TEST_CASE macro.
    + Add 1004_remove-cmake-instructions-that-have-been-moved-into-
      FindGMock.patch. Drop CMake instructions that have been moved into
      FindGMock of cmake-extras.
    + Add 1005_add-missing-pthread-to-link-target.patch. Add missing -pthread
      linker argument. Probably to hard-coded, but works for now.
    + Add 2001_no-convert-to-gles-test.patch and 2002_no-requires-provides-
      check.patch. Disable tests fiddling around with files in debian/*. Not
      wanted by Debian maintainer.
    + Add 1006_make-sure-tracepoints-h-exists.patch. Make sure tracepoints.h
      exists for building library 'qtmirserver-mirserver'.
    + Add upstream bugs for all 100* patches.
    + Refer to a bug report for Debian-specific patches 200*_*.patch.
  * debian/source/format:
    + Add file.
  * debian/copyright:
    + Add auto-generated copyright.in file.
    + Rework copyright attributions, use individual-code-file style.
    + Also mention files we remove via patch.
  * debian/upstream/metadata:
    + Add file. Comply with DEP-12.
  * debian/libqtmirserver1.symbols:
    + Add file.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 25 Oct 2020 01:31:45 +0200

qtmir (0.6.0ubuntu5) xenial; urgency=medium

  * Merge Multiscreen branch

  [ Nick Dedekind ]
  * Introduced QtMir API
  * Support for multiple compositors per MirSurface


=== debian/control ===
Source: qtmir
Section: libs
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>,
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               cmake-extras (>= 1.5-4~),
               debhelper-compat (= 13),
               googletest (>= 1.6.0+svn437),
               libfontconfig1-dev,
               libgles2-mesa-dev,
               libglib2.0-dev,
               libgsettings-qt-dev,
               libgtest-dev,
               liblttng-ust-dev,
               libmiral-dev (>= 1.2),
               libmircommon-dev (>= 0.26.0),
               libmirserver-dev (>= 0.26.0),
               libmtdev-dev,
               libprocess-cpp-dev,
               libqt5sensors5-dev,
               libqtdbusmock1-dev (>= 0.2),
               libqtdbustest1-dev (>= 0.2),
               liblomiri-app-launch-dev,
               libudev-dev,
               liblomiri-api-dev (>= 0.1.1),
               liblomiri-url-dispatcher-dev,
               libxkbcommon-dev,
               libxrender-dev,
               mir-renderer-gl-dev (>= 0.26.0),
               mirtest-dev (>= 0.26.0),
               pkg-config,
               pkg-kde-tools,
# lttng-gen-ts needs python3, but doesn't depend on it itself: bug 1359147
               python3:any,
               qtbase5-dev,
               qtbase5-private-dev,
               qtdeclarative5-dev,
               qtdeclarative5-private-dev,
               quilt,
               valgrind [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x powerpc ppc64 x32],
# libmirserver-dev should have brought this dep. Bug lp:1617435
               uuid-dev,
# mirtest pkgconfig requires these, but doesn't have a deb dependency. Bug lp:1633537
               libboost-filesystem-dev,
               libboost-system-dev,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://github.com/ubports/qtmir
Vcs-Git: https://salsa.debian.org/ubports-team/qtmir.git
Vcs-Browser: https://salsa.debian.org/ubports-team/qtmir

Package: qtmir-android
Architecture: armhf arm64
Multi-Arch: same
Conflicts: qtmir-desktop,
           qtubuntu-desktop,
Replaces: qtmir-desktop,
          qtubuntu-desktop,
Provides: qtmir,
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Qt platform abstraction (QPA) plugin for a Mir server (mobile)
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 This variant of the package is for Android-based phones and tablets.

Package: qtmir-desktop
Architecture: linux-any
Multi-Arch: same
Conflicts: qtmir-android,
           qtubuntu-android,
Replaces: qtmir-android,
          qtubuntu-android,
Provides: qtmir,
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Qt platform abstraction (QPA) plugin for a Mir server (desktop)
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 This variant of the package is for GNU-based desktops.

Package: libqtmirserver-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: qtmir-desktop (= ${binary:Version}) | qtmir-android (= ${binary:Version}),
         ${misc:Depends},
         libmiral-dev (>= 1.3.0),
Description: Developer files for QtMir server API
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 This package contains the library headers for developers.

Package: libqtmirserver1
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
      ${shlibs:Depends},
Description: QtMir server API shared library
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 Contains the shared library containing QtMir server API.

Package: qml-module-qtmir
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: qtmir-desktop (= ${binary:Version}) | qtmir-android (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Provides: lomiri-application-impl,
          lomiri-application-impl-27,
Description: Qt/QML module for Lomiri specific Mir APIs
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 QtMir provides Qt/QML bindings for Mir features that are exposed through the
 qtmir-desktop or qtmir-android QPA plugin such as Application management
 (start/stop/suspend/resume) and surface management.

Package: qtmir-tests
Section: libdevel
Architecture: linux-any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends},
Depends: littler,
         lttng-tools,
         mir-test-tools,
         python3-babeltrace,
         python3-evdev,
         python3-mir-perf-framework,
         qml-module-qtmir,
         qtmir-desktop (= ${binary:Version}) | qtmir-android (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: QtMir tests and demos
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 This package provides benchmark tests and a simple shell and client using the
 QtMir QPA.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

include /usr/share/dpkg/default.mk

include /usr/share/dpkg/buildflags.mk
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ANDROID_DIR = build-android
DESKTOP_DIR = build-desktop
TMP1_DIR = $(CURDIR)/debian/tmp1
TMP2_DIR = $(CURDIR)/debian/tmp2

# We only want to build qtmir-android on arches using Qt built with OpenGL ES2.0
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
gles2_architectures = armhf arm64

USES_GLES2 = $(findstring $(DEB_HOST_ARCH), $(gles2_architectures))

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_missing:
	dh_missing --fail-missing

override_dh_clean:
ifeq ($(DEB_HOST_ARCH),$(USES_GLES2))
	rm -rf $(TMP1_DIR)
endif
	rm -rf $(TMP2_DIR)
	dh_clean

override_dh_auto_clean:
	dh_auto_clean
	rm build-*/ -Rfv

override_dh_auto_configure:
ifeq ($(DEB_HOST_ARCH),$(USES_GLES2))
	mkdir -p $(ANDROID_DIR) && dh_auto_configure -B$(ANDROID_DIR) -- $(FLAGS) $(CURDIR) -DUSE_OPENGLES=1 -DWerror=OFF
# See comment in CMakeLists.txt
	mkdir -p $(DESKTOP_DIR) && dh_auto_configure -B$(DESKTOP_DIR) -- $(FLAGS) $(CURDIR) -DUSE_OPENGL_BUT_LINK_AGAINST_OPENGLES=1 -DWerror=OFF
else
	mkdir -p $(DESKTOP_DIR) && dh_auto_configure -B$(DESKTOP_DIR) -- $(FLAGS) $(CURDIR) -DUSE_OPENGLES=1 -DWerror=OFF
endif

override_dh_auto_build:
ifeq ($(DEB_HOST_ARCH),$(USES_GLES2))
	dh_auto_build -B$(ANDROID_DIR)
endif
	dh_auto_build -B$(DESKTOP_DIR)

override_dh_auto_test:
ifeq ($(DEB_HOST_ARCH),$(USES_GLES2))
	dh_auto_test -B$(ANDROID_DIR)
endif
	dh_auto_test -B$(DESKTOP_DIR)

override_dh_auto_install:
ifeq ($(DEB_HOST_ARCH),$(USES_GLES2))
	dh_auto_install -B$(ANDROID_DIR) --destdir=$(TMP1_DIR)
endif
	dh_auto_install -B$(DESKTOP_DIR) --destdir=$(TMP2_DIR)

override_dh_install:
ifeq ($(DEB_HOST_ARCH),$(USES_GLES2))
	#clean gmock/gtest if it built in our build dir
	-rm -f $(TMP1_DIR)/usr/lib/libgmock*.a $(TMP1_DIR)/usr/lib/libgtest*.a
	-rm -rf $(TMP1_DIR)/usr/include/gmock $(TMP1_DIR)/usr/include/gtest
	dh_install --sourcedir=$(TMP1_DIR) -pqtmir-android
endif
	#move qtmir-demo-shell and qtmir-demo-client files to the correct location
	mv $(TMP2_DIR)/usr/share/qtmir/qtmir-demo-shell $(TMP2_DIR)/usr/share/qtmir/qml-demo-shell/
	mv $(TMP2_DIR)/usr/share/qtmir/qtmir-demo-client $(TMP2_DIR)/usr/share/qtmir/qml-demo-client/
	#clean gmock/gtest if it built in our build dir
	-rm -f $(TMP2_DIR)/usr/lib/libgmock*.a $(TMP2_DIR)/usr/lib/libgtest*.a
	-rm -rf $(TMP2_DIR)/usr/include/gmock $(TMP2_DIR)/usr/include/gtest
	dh_install --sourcedir=$(TMP2_DIR) -pqtmir-desktop
	dh_install --sourcedir=$(TMP2_DIR) -pqml-module-qtmir
	dh_install --sourcedir=$(TMP2_DIR) -pqtmir-tests
	dh_install --sourcedir=$(TMP2_DIR) -plibqtmirserver1
	dh_install --sourcedir=$(TMP2_DIR) -plibqtmirserver-dev

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
https://gitlab.com/ubports/core/qtmir/tags .*/qtmir-(\d\S+)\.tar\.gz

## qtmir 0.7.0

=== debian/changelog ===
qtmir (0.7.0-2) unstable; urgency=medium

  [ Mike Gabriel ]
  * debian/control:
    + Update Homepage: field. Use upstream GitLab URL (instead of deprecated
      Github URL).

  [ Marius Gripsgard ]
  * debian/libqtmirserver1.symbols:
    + Refresh symbol file from buildd logs using pkgkde-symbolshelper.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 25 May 2022 23:48:32 +0200

qtmir (0.7.0-1) unstable; urgency=medium

  [ Marius Gripsgard ]
  * New upstream release v0.7.0
  * debian/patches: Drop upstreamed and unneeded patches, refresh patches:
    + Drop upstreamed and unneeded patches:
     - 0001_demo-fix-detecting-running-installed.patch
     - 0002_demos-fix-application-name.patch
     - 1002_drop-cgmanager-dependency.patch
     - 1003_INSTANTIATE_TEST_SUITE.patch
     - 1004_remove-cmake-instructions-that-have-been-moved-into-FindGMock.patch
     - 1005_add-missing-pthread-to-link-target.patch
     - 1006_make-sure-tracepoints-h-exists.patch
     - 1007_make-valgrind-dependency-optional.patch
     - 1008_drop-Werror-enforcement-leave-it-to-configure-option.patch
     - 2001_no-convert-to-gles-test.patch
     - 2004_qml-demo-shell-work-without-ui-toolkit.patch
    + Refreshed patches:
     - 2002_no-requires-provides-check.patch
     - 2003_disable-benchmarks.patch
  * debian/copyright: Update copyright to match new upstream release
  * debian/symbols: Update symbols to match new upstream release
  * debian/control: Drop qtmir-{android/desktop} and use a generic qtmir package
  * debian/control: Add myself as uploader
  * debian/control: Bump required versions for cmake-extras and googletest
  * debian/rules: Clean up rules and remove dual binary build (was for
    android/desktop split)
  * debian/qtmir-tests: Rename paths to match upstream renames
  * debian/control: Add qml-module-lomiri-components as DEP for qtmir-tests

  [ Mike Gabriel ]
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update more copyright attributions, finalize for upload.
  * debian/control:
    + Improve transitional packages, provide former info on the packages'
      content. Thanks, lintian.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 23 Apr 2022 09:45:49 +0200

qtmir (0.6.1-8) unstable; urgency=medium

  * debian/rules:
    + Comment out DPKG_GENSYMBOLS_CHECK_LEVEL=4. Let's use level 1 (default)
      and receive less build failures. (related to #997464).
  * debian/control:
    + Bump Standards-Version: to 4.6.0. No changes needed.
  * debian/libqtmirserver1.symbols:
    + Update symbols after build with gcc-11. (Closes: #997464).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 13 Nov 2021 21:05:14 +0100

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,11 @@
 Uploaders:
  Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>,
  Mike Gabriel <sunweaver@debian.org>,
+ Marius Gripsgard <marius@ubports.com>,
 Build-Depends: cmake,
-               cmake-extras (>= 1.5-4~),
+               cmake-extras (>= 1.6~),
                debhelper-compat (= 13),
-               googletest (>= 1.6.0+svn437),
+               googletest (>= 1.10.0),
                libfontconfig1-dev,
                libgles2-mesa-dev,
                libglib2.0-dev,
@@ -40,58 +41,66 @@
                qtdeclarative5-dev,
                qtdeclarative5-private-dev,
                quilt,
-               valgrind [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x powerpc ppc64 x32],
+               valgrind-if-available,
 # libmirserver-dev should have brought this dep. Bug lp:1617435
                uuid-dev,
 # mirtest pkgconfig requires these, but doesn't have a deb dependency. Bug lp:1633537
                libboost-filesystem-dev,
                libboost-system-dev,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
-Homepage: https://github.com/ubports/qtmir
+Homepage: https://gitlab.com/ubports/core/qtmir
 Vcs-Git: https://salsa.debian.org/ubports-team/qtmir.git
 Vcs-Browser: https://salsa.debian.org/ubports-team/qtmir
+
+Package: qtmir
+Architecture: linux-any
+Multi-Arch: same
+Breaks: qtmir-android (<< 0.7.0~),
+        qtmir-desktop (<< 0.7.0~),
+Replaces: qtmir-android (<< 0.7.0~),
+          qtmir-desktop (<< 0.7.0~),
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+Description: Qt platform abstraction (QPA) plugin for a Mir server
+ QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
+ It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
+ a Mir server. It also exposes some internal Mir functionality.
 
 Package: qtmir-android
 Architecture: armhf arm64
 Multi-Arch: same
-Conflicts: qtmir-desktop,
-           qtubuntu-desktop,
-Replaces: qtmir-desktop,
-          qtubuntu-desktop,
-Provides: qtmir,
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-Description: Qt platform abstraction (QPA) plugin for a Mir server (mobile)
- QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
- It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
- a Mir server. It also exposes some internal Mir functionality.
+Depends: qtmir, ${misc:Depends},
+Section: oldlibs
+Description: QPA plugin for a Mir server (mobile, transitional package)
+  QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
+  It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
+  a Mir server. It also exposes some internal Mir functionality.
  .
  This variant of the package is for Android-based phones and tablets.
+ .
+ This is a transitional package. It can safely be removed.
 
 Package: qtmir-desktop
 Architecture: linux-any
 Multi-Arch: same
-Conflicts: qtmir-android,
-           qtubuntu-android,
-Replaces: qtmir-android,
-          qtubuntu-android,
-Provides: qtmir,
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-Description: Qt platform abstraction (QPA) plugin for a Mir server (desktop)
+Depends: qtmir, ${misc:Depends},
+Section: oldlibs
+Description: QPA plugin for a Mir server (desktop, transitional package)
  QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
  It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
  a Mir server. It also exposes some internal Mir functionality.
  .
  This variant of the package is for GNU-based desktops.
+ .
+ This is a transitional package. It can safely be removed.
 
 Package: libqtmirserver-dev
 Section: libdevel
 Architecture: linux-any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends: qtmir-desktop (= ${binary:Version}) | qtmir-android (= ${binary:Version}),
+Depends: qtmir (= ${binary:Version}),
          ${misc:Depends},
          libmiral-dev (>= 1.3.0),
 Description: Developer files for QtMir server API
@@ -118,7 +127,7 @@
 Architecture: linux-any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends},
-Depends: qtmir-desktop (= ${binary:Version}) | qtmir-android (= ${binary:Version}),
+Depends: qtmir (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends},
 Provides: lomiri-application-impl,
@@ -129,8 +138,8 @@
  a Mir server. It also exposes some internal Mir functionality.
  .
  QtMir provides Qt/QML bindings for Mir features that are exposed through the
- qtmir-desktop or qtmir-android QPA plugin such as Application management
- (start/stop/suspend/resume) and surface management.
+ qtmir QPA plugin such as Application management (start/stop/suspend/resume)
+ and surface management.
 
 Package: qtmir-tests
 Section: libdevel
@@ -143,8 +152,9 @@
          python3-babeltrace,
          python3-evdev,
          python3-mir-perf-framework,
+         qml-module-lomiri-components,
          qml-module-qtmir,
-         qtmir-desktop (= ${binary:Version}) | qtmir-android (= ${binary:Version}),
+         qtmir (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends},
 Description: QtMir tests and demos

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to be more picky with non-updated .symbols files
#export DPKG_GENSYMBOLS_CHECK_LEVEL=4

include /usr/share/dpkg/default.mk

include /usr/share/dpkg/buildflags.mk
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_missing:
	dh_missing --fail-missing

FLAGS := -DWerror=OFF
# Explicitly disable building with Valgrind on architectures without it.
valgrind_architectures := amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x powerpc ppc64 x32
ifeq ($(filter $(DEB_HOST_ARCH), $(valgrind_architectures)),)
	FLAGS += -DWITH_VALGRIND=OFF
endif

override_dh_auto_configure:
	dh_auto_configure -- $(FLAGS)

override_dh_install:
	#clean gmock/gtest if it built in our build dir
	-rm -f debian/tmp/usr/lib/libgmock*.a debian/tmp/usr/lib/libgtest*.a
	-rm -rf debian/tmp/usr/include/gmock debian/tmp/usr/include/gtest
	dh_install

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
